<?php

#
# i-scream central monitoring system
# http://www.i-scream.org
# Copyright (C) 2000-2002 i-scream
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

# Navigation for the i-scream graphs
# tim@i-scream.org
#
# CONFIGURABLE CONSTANTS: -

include("graphs_config.inc.php");

#
# END CONFIGURATION


include("iutils.inc.php");

if ($formMethod == "GET") {
    $machine_name = isset($_GET['machine_name']) ? $_GET['machine_name'] : "";
    $graph = isset($_GET['graph']) ? $_GET['graph'] : "";
    $submit = isset($_GET['submit']) ? $_GET['submit'] : "";
    $PHP_SELF = isset($_GET['PHP_SELF']) ? $_GET['PHP_SELF'] : "";
}

$file_array = getdirArray($imgdir,'asort');

?>

<?php include($titleHTML); ?>

<hr weight="1" color="<?php echo $lineColor ?>">

<b>Graphs available for these machines:</b>

<form method="<?php echo $formMethod ?>" action="<?php echo $thisPage ?>">
 <select size="1" name="machine_name">
  <?php if ($machine_name) { ?>
    <option selected value="<?php echo $machine_name ?>"><?php echo $machine_name ?></option>
    <option value="">----------------</option>
  <?php } else { ?>
    <option selected value="">[select machine]</option>
  <?php } ?>
  <?php
     foreach($file_array as $file_name) {
        if(is_dir("$imgdir/$file_name")) { ?>
            <option value="<?php echo $file_name ?>"><?php echo $file_name ?></option>
     <?php }
     }
  ?>
 </select>

 <input type="submit" name="submit" value="Go">
</form>

<hr weight="1" color="<?php echo $lineColor ?>">

<?php if ($machine_name) { ?>
    
    <b>Available graphs for <?php echo $machine_name ?></b>
    
    <form method="<?php echo $formMethod ?>" action="<?php echo $thisPage ?>">
     <select size="1" name="graph">
      <?php if ($graph) { ?>
        <option selected value="<?php echo $graph ?>"><?php echo tidyName($machine_name, $graph) ?></option>
        <option value="">----------------</option>
      <?php } else { ?>
        <option selected value="">[select graph]</option>
      <?php } ?>
      <option value="ALL">ALL</option>
      <?php
         $file_array = getdirArray("$imgdir/$machine_name",'asort');
         foreach($file_array as $file_name) {
            if(preg_match("/^(\S+)\-3h.png$/", $file_name, $matches)) { ?>
                <option value="<?php echo $matches[1] ?>"><?php echo tidyName($machine_name, $matches[1]) ?></option>
         <?php }
         }
      ?>
     </select>
     
     <input type="hidden" name="machine_name" value="<?php echo $machine_name ?>">
     <input type="submit" name="submit" value="Show">
    </form>
    
    <hr weight="1" color="<?php echo $lineColor ?>">

<?php } ?>

</p>


<?php
    if ($submit == "Show" && $machine_name && $graph) {
      if ($graph == "ALL") {
      ?>
        <center><b>[<?php echo $machine_name; ?>] - All graphs</b></center>

        <center>
        <?php
         foreach($file_array as $file_name) {
            if(preg_match("/^(\S+)\-3h.png$/", $file_name, $matches)) { ?>
                <p><b><?php echo tidyName($machine_name, $matches[1]) ?>:</b><br>
                <a href="<?php echo $PHP_SELF.'?'.'graph='.$matches[1].'&machine_name='.$machine_name.'&submit=Show'?>">
                <img border="0" src="<?php echo "$imgwebdir/$machine_name/$matches[1]-3h.png" ?>"></a></p>
            <?php }
         }
         ?>
        </center>
      <?php
      } else { // if graph== All
      ?>
        <center><b>[<?php echo $machine_name; ?>] - '<?php echo tidyName($machine_name, $graph) ?>' graphs</b></center>
        
        <center>
         <p><b>Last 3 hours :</b><br><img border="0" src="<?php echo "$imgwebdir/$machine_name/$graph-3h.png" ?>"></p>
         <p><b>Last day :</b><br><img border="0" src="<?php echo "$imgwebdir/$machine_name/$graph-1d.png" ?>"></p>
         <p><b>Last week :</b><br><img border="0" src="<?php echo "$imgwebdir/$machine_name/$graph-1w.png" ?>"></p>
         <p><b>Last month :</b><br><img border="0" src="<?php echo "$imgwebdir/$machine_name/$graph-1m.png" ?>"></p>
         <p><b>Last year :</b><br><img border="0" src="<?php echo "$imgwebdir/$machine_name/$graph-1y.png" ?>"></p>
        </center>
      <?php } /* if graph == All */ ?> 
        <hr weight="1" color="<?php echo $lineColor ?>">
        
        <b>Latest data</b>
        <p>
        Latest set of data received from 
        <a href="<?php echo "latest.php?machine=$machine_name"; ?>"><?php echo $machine_name?></a>
        <br>
        Alerts for <a href="alerts.php?machine=<?php echo $machine_name?>"><?php echo $machine_name?></a>


        <hr weight="1" color="<?php echo $lineColor ?>">
 <?php } // if show, machine and graph
?>

<?php include($bottomHTML); ?>
