<?php

#
# i-scream central monitoring system
# http://www.i-scream.org
# Copyright (C) 2000-2002 i-scream
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

# CONFIGURABLE CONSTANTS: -

include("latest_config.inc.php");

#
# END CONFIGURATION

include("iutils.inc.php");

if ($formMethod == "GET") {
    $machine = isset($_GET['machine']) ? $_GET['machine'] : "";
}


function printLine($title) {
    echo "<hr style=\"color:#9999ff;\">";
    echo "<b>$title</b>";
}


function showUptime($title, $value, $input, $graph="") {
    $report = $value;

    $value = getPregMatch($value, $input);
    if (!isset($value)) {
        $value = "<i><font color=\"#999999\">not sent</font></i>";
    }
    ?>
        <table border="0" width="100%">
          <tr>
            <td width="50%" align="right" valign="top">
             <b><?php echo $title?></b>
            </td>
            <td width="50%" align="left" valign="top">
             <?php if (preg_match("/^[0-9]+\.?[0-9]*$/", $value)) {
                    linkToHistory($graph);
                } ?>
              <?php echo uptime($value)?> (<?php echo $value?> seconds)</td>
          </tr>
        </table>
    <?php
}


function showStat($title, $value, $input, $graph="") {

    $report = $value;

    $value = getPregMatch($value, $input);
    if (!isset($value)) {
        $value = "<i><font color=\"#999999\">not sent</font></i>";
    }
    ?>
        <table border="0" width="100%">
          <tr>
            <td width="50%" align="right" valign="top">
             <b><?php echo $title?></b>
            </td>
            <td width="50%" align="left" valign="top">
             <?php if (preg_match("/^[0-9]+\.?[0-9]*$/", $value)) {
                    linkToHistory($graph);
                } ?> 
              <?php echo $value?></td>
          </tr>
        </table>
    <?php
}


function linkToHistory($graph) {
    global $machine;
    if(!empty($graph)) {
        echo <<<EOT
        <a href="graphs.php?machine_name=$machine&graph=$graph&submit=Show"><img src="minichart.gif" alt="View historical graphs of this data" width="20" height="20" border="0"></a>
EOT;
    }
}


# convert bytes to MB
function b2Mb($bytes) {
    $mb = $bytes / (1024*1024);
    return (int) $mb;
}


# Convert seconds uptime to something readable
function uptime($until) {
    $day = date('z', $until);
    $hour = date('G', $until);
    if ($hour == 0) { # everything's an hour ahead, so roll back
        $hour = 23;
        $day = $day - 1;
    } else {
        $hour = $hour - 1;
    }
    $minute = date('i', $until);
    $return = "";
    if ($day) {
        $return = "$return$day";
        if ($day == 1) {
            $return = "$return Day ";
        } else {
            $return = "$return Days ";
        }
    }
    if ($hour) {
        $return = "$return$hour";
        if ($hour == 1) {
            $return = "$return Hour ";
        } else {
            $return = "$return Hours ";
        }
    }
    $return = "$return$minute";
    if ($minute == 1) {
        $return = "$return Min";
    } else {
        $return = "$return Mins";
    }
    return $return;
}


# show all disk information.
function showDisks($diskRoot, $units, $input) {
    include("latest_config.inc.php");

    $i = 0;
    while(1) {
        $name = getPregMatch("$diskRoot.p$i.attributes.name", $input);
        $mount = getPregMatch("$diskRoot.p$i.attributes.mount", $input);
        if ($name || $mount) {
            $used = "$diskRoot.p$i.attributes.used";
            $total = "$diskRoot.p$i.attributes.total";
            $graph = preg_replace("/_/", "$hex_underscore", $mount);
            $graph = preg_replace("/\//", "$hex_slash", $graph);
            $graph = preg_replace("/\\\\/", "$hex_bslash", $graph);
            $graph = preg_replace("/ /", "$hex_space", $graph);
            $graph = preg_replace("/:/", "$hex_colon", $graph);
            $totalinodes = getPregMatch("$diskRoot.p$i.attributes.totalinodes", $input);
            $freeinodes = getPregMatch("$diskRoot.p$i.attributes.freeinodes", $input);
            showBar("$name ($mount)<br>space used", $used, $total, $units, $input, "disk-$graph");
            showBar("inodes used", (float) $freeinodes, (float) $totalinodes, " inodes", $input, "", "swap");
            showStat("FS Type", "$diskRoot.p$i.attributes.fstype", $input);
            print "          <br><br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# show all disk IO information.
function showDiskIO($diskRoot, $input) {
    include("latest_config.inc.php");
 
    $i = 0;
    while(1) {
        $name = getPregMatch("$diskRoot.p$i.attributes.name", $input);
        if ($name) {
            $graph = preg_replace("/_/", "$hex_underscore", $name);
            $graph = preg_replace("/\//", "$hex_slash", $graph);
            $graph = preg_replace("/\\\\/", "$hex_bslash", $graph);
            $graph = preg_replace("/ /", "$hex_space", $graph);
            $graph = preg_replace("/:/", "$hex_colon", $graph);
            print "<br><center><b>(Disk $name)</b></center>";
            showStat("Read bytes (per sec)", "$diskRoot.p$i.attributes.rbytes", $input, "diskio-$graph");
            showStat("Write bytes (per sec)", "$diskRoot.p$i.attributes.wbytes", $input, "diskio-$graph");
            print "          <br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# show all network information.
function showNet($netRoot, $input) {
    include("latest_config.inc.php");

    $i = 0;
    while(1) {
        $name = getPregMatch("$netRoot.p$i.attributes.name", $input);
        if ($name) {
            $graph = preg_replace("/_/", "$hex_underscore", $name);
            $graph = preg_replace("/\//", "$hex_slash", $graph);
            $graph = preg_replace("/\\\\/", "$hex_bslash", $graph);
            $graph = preg_replace("/ /", "$hex_space", $graph);
            $graph = preg_replace("/:/", "$hex_colon", $graph);
            $graph = preg_replace("/\(/", "$hex_lbracket", $graph);
            $graph = preg_replace("/\)/", "$hex_rbracket", $graph);
            $graph = preg_replace("/\+/", "$hex_plus", $graph);
            $graph = preg_replace("/#/", "$hex_hash", $graph);
            print "<br><center><b>(Network Interface $name)</b></center>";
            showStat("Received bytes (per sec)", "$netRoot.p$i.attributes.rx", $input, "net-$graph");
            showStat("Transfered bytes (per sec)", "$netRoot.p$i.attributes.tx", $input, "net-$graph");
            print "          <br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# show all mail queue information
function showMailQ($mailqRoot, $input) {
    include("latest_config.inc.php");

    $i = 0;
    while(1) {
        $name = getPregMatch("$mailqRoot.p$i.attributes.name", $input);
        if ($name) {
            print "<br><center><b>($name)</b></center>";
            $name = preg_replace("/\s+/", "", $name);
            showStat("Messages in queue", "$mailqRoot.p$i.attributes.size", $input, "mailq-$name");
            print "          <br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# Return a preg_match result.
function getPregMatch($value, $input) {
    preg_match("/$value=([^\,\}]*)[\,\}]/", $input, $matches);
    if(!isset($matches[1])) {
        return;
    }
    return $matches[1];
}


# show a bar-represented value.
function showBar($title, $value, $max, $units, $input, $graph="", $arrange='normal') {

    include("latest_config.inc.php");

    $report = $value;
    if (!is_int($value)) {
        $value = getPregMatch($value, $input);
    }
    if (!is_int($max)) {
        $max = getPregMatch($max, $input);
    }
    if (!isset($value) || !isset($max)) {
        return;
    }

    if ($arrange == 'swap') {
        $value = $max - $value;
    }

    if ($units == 'MB') {
        $value = b2Mb ($value);
        $max = b2Mb ($max);
    }

    if(empty($max)) {
        $width = 1;
    }
    else {
        $width = intval($max_width * $value / $max);
        if ($width < 1) {
            $width = 1;
        }
    }

    ?>
        <table border="0" cellpadding="0" cellspacing="0" align="center">
          <tr>
            <td colspan="2"><?php linkToHistory($graph); ?> <b><?php echo $title?></b> <font size="2">(<?php echo $value?><?php echo $units?>)</font></td>
          </tr>
          <tr>
            <td colspan="2" bgcolor="#eeeeff"><img src="<?php echo $barImage?>" border="0" height="20" width="<?php echo $width?>"></td>
          </tr>
          <tr>
            <td colspan="2"><img src="<?php echo $scaleImage?>" border="0" height="11" width="<?php echo $max_width?>"></td>
          </tr>
          <tr>
            <td align="left">0<?php echo $units?></td>
            <td align="right"><?php echo $max?><?php echo $units?></td>
          </tr>
        </table>
    <?php
}


?>

<?php include($titleHTML); ?>

<?php printLine("Display the latest information received from a host"); ?>

<form method="<?php echo $formMethod ?>" action="<?php echo $thisPage ?>">
<?php

    $file_array = getdirArray($latestDirectory,'asort');
    print "<select size=\"1\" name=\"machine\">";
    if ($machine) { ?>
        <option selected value="<?php echo $machine ?>"><?php echo $machine ?></option>
        <option value="">----------------</option>
    <?php }
    foreach($file_array as $file_name) {
        #if (is_dir($file_name)) {
            print "<option value=\"$file_name\">$file_name</option>";
        #}
    }
    print "</select>";

?>
 <input type="submit" name="submit" value="Display">
</form>

<?php if ($machine) {

       $last_modified = filemtime("$latestDirectory/$machine/$latestData");
       clearstatcache();
       $data_age = time() - $last_modified;

       $last_modified = date("l jS F Y - g:ia", $last_modified);

       if ($data_age > $warning_age) {
           $warning = <<<EOT
               <br>
               <font color="red"><b>
                   Warning:
               </b></font>
                   This realtime report is too old to be considered recent
EOT;
       }
       else {
           $warning = "";
       }

echo <<<EOT
       <table border="0" bgcolor="#000066" cellpadding="3" cellspacing="1">
         <tr>
           <td bgcolor="#000066">
             &nbsp;
           </td>
           <td bgcolor="#ffffcc">
             <font face="arial,sans-serif" size="2">
               <b>Receipt date:</b> $last_modified
               $warning
             </font>
           </td>
         </tr>
       </table>
EOT;

       # Read the file.
       if (file_exists("$latestDirectory/$machine/$latestData")) {
           $input = file("$latestDirectory/$machine/$latestData");
           # All we need is the first line if there is more than one line.
           $input = $input[0];
       }

       if (!isset($input)) {
           echo "<br><br>There are currently no latest details about <b>$machine</b>.  Please notify your i-scream server administrator if you believe this to be incorrect.";
       }
       else {
           # Display the data specified in the display include.
           include("latest_display.inc.php");
       }
   }

?>

<?php printLine(""); ?>

<?php include($bottomHTML); ?>
